# Tracker Flight quick look 
# SOFTWARE VERSION
VER= v1r34
# An almost general purpouse Makefile for PAMELA repository
# Let's start with some usefull definition for colorize the echo 
RED='\E[1;31;40m'
GREEN='\E[1;32;40m'
YELLOW='\E[1;33;40m'
BLUE='\E[1;34;40m'
WHITE='\E[1;37;40m'
VIOLET='\E[1;35;40m'
CYAN='\E[1;36;40m'
# Here the echo definition to use them
EVIOLET=echo -e ${VIOLET}
ECYAN=echo -e ${CYAN}
ERED=echo -e ${RED}
EGREEN=echo -e ${GREEN}
EYELLOW=echo -e ${YELLOW}
EBLUE=echo -e ${BLUE}
EWHITE=echo -e ${WHITE}
# Reset the terminal
RESET=tput sgr0
# Here the variables used to override the standard make flags
# C
CC=gcc
CFLAGS=-Wall -O -fPIC -pthread
# Enviroment:
GCCVER=`gcc --version | head -1`
UNAMEA=`uname -a`
TODAY=`date`
# F77
F77=g77
F77FLAGS=  -Wall -Wno-globals -fvxt -fno-automatic -fbounds-check -g -extend_source -static -fno-backslash
# C++
CXX=g++
CXXFLAGS=-Wall -O -fPIC -pthread ${PAM_BIT}
# ROOTCINT
ROOTCINT=rootcint
# Here the variables definig the local directories
DIRTOP=${shell pwd}
DIRLIB=lib
DIRBIN=bin
DIRSRC=src
DIRINC=inc
DIRDOC=doc
DIRMACROS=macros
# Here the  PAMELA environmental variables to be checked
PAM_ENV= PAM_BIN_env PAM_LIB_env PAM_INC_env PAM_DOC_env PAM_MACROS_env PAM_YODA_env 
# Here the local variables used to build the targets

MACROSRCS=${DIRMACROS}/FTrkQLook_BASIC.cxx \
	  ${DIRMACROS}/FTrkQLook_EXPERT.cxx \
	  ${DIRMACROS}/FTrkCalibQLook_BASIC.cxx \
	  ${DIRMACROS}/FTrkCalibQLook_EXPERT.cxx \
	  ${DIRMACROS}/FTrkScanQLook_EXPERT.cxx 
MACROSLIBS=$(MACROSRCS:${DIRMACROS}/%.cxx=${DIRLIB}/lib%_${VER}.so)
MACROCLIBS=libFTrkQLook_BASIC libFTrkQLook_EXPERT libFTrkCalibQLook_BASIC libFTrkCalibQLook_EXPERT libFTrkScanQLook_EXPERT 
FULLMACROCLIBS=$(MACROCLIBS:%=${DIRLIB}/%_${VER}.so)
FULLLINKMACROCLIBS=$(MACROCLIBS:%=${DIRLIB}/%.so)

CXXEXESRCS=${DIRSRC}/FTrkQLook_BASIC.cc \
	   ${DIRSRC}/FTrkQLook_EXPERT.cc \
	   ${DIRSRC}/FTrkCalibQLook_BASIC.cc \
	   ${DIRSRC}/FTrkCalibQLook_EXPERT.cc \
	   ${DIRSRC}/FTrkScanQLook_EXPERT.cc
CXXEXEOBJS=$(CXXEXESRCS:${DIRSRC}%.cc=${DIRBIN}%.o)
CXXEXELIBS:=FTrkQLook_BASIC FTrkQLook_EXPERT FTrkCalibQLook_BASIC FTrkCalibQLook_EXPERT FTrkScanQLook_EXPERT 

EXESRCS= ${DIRBIN}/FTrkQLook_BASIC ${DIRBIN}/FTrkQLook_EXPERT ${DIRBIN}/FTrkCalibQLook_BASIC ${DIRBIN}/FTrkCalibQLook_EXPERT ${DIRBIN}/FTrkScanQLook_EXPERT

INCSRCS= 

MACROSSRCS=${DIRMACROS}/FTrkQLook_BASIC.C ${DIRMACROS}/FTrkQLook_EXPERT.C ${DIRMACROS}/FTrkCalibQLook_BASIC.C ${DIRMACROS}/FTrkCalibQLook_EXPERT.C ${DIRMACROS}/FTrkScanQLook_EXPERT.C

DOCFILES=${DIRDOC}/FlightTrkQLook-OperatorManual.doc ${DIRDOC}/FlightTrkQLook-OperatorManual.pdf 

# Here the Variables used for info target
PACKAGE=Tracker flight quick look software 
EXECUTABLES=
LIBS= ${FLIBS} ${FOBJS} ${CLIBS} ${COBJS} ${CXXEXEOBJS}
DOCS=
SRCS= ${FSRCS} ${CRSCS} ${CXXEXESRCS}
MACROS= ${MACROSSRCS}
#
TOBEDEL = junk
ROOTINC=$$${shell root-config --incdir}
# Let's start
all : test mkbindir mklibdir ${MACROSLIBS} ${CXXEXELIBS} 
all: 
	@echo -e ${GREEN} ""
	@(${EGREEN} " Finished, now you can install the package \n  (use: make install or make upgrade or make forceinstall) "; ${RESET})
	@echo -e ${GREEN} ""
	@${RESET}

# Here some general rules to produce objects in our local dir
 ${DIRBIN}/%.o: ${DIRSRC}/%.cc
	@(${EGREEN} "Creating object file: "${WHITE} "$@"; ${RESET})
	@cat ${DIRSRC}/`basename ${@} .o`.cc > ${DIRSRC}/temp.cc;
	@echo ' ' >> ${DIRSRC}/temp.cc
	@echo 'void info(){ printf("\nQLOOK flight package version: ${VER}\n\nCompiled on '${TODAY}' with: '${GCCVER}'\n\nOn: '${UNAMEA}'\n\n"); }' >> ${DIRSRC}/temp.cc
	@${CXX} ${CXXFLAGS} -c -o $@ ${DIRSRC}/temp.cc -I${DIRINC} -I${PAM_INC} -I${PAM_YODA}/include/yoda `root-config --cflags`


${MACROSLIBS}: ${MACROSRCS}
	@(${EGREEN} "Compiling macro: "${WHITE} "$@"; ${RESET})
	@${ROOTCINT} -f ${DIRMACROS}/`basename $(@F) _${VER}.so  | sed s/lib//`link.cxx -c -I${ROOTINC} ${DIRINC}/`basename $(@F) _${VER}.so  | sed s/lib//`func.h ${DIRINC}/`basename $(@F) _${VER}.so  | sed s/lib//`LinkDef.h
	@${CXX} ${CXXFLAGS} -Xlinker -soname=$(@F) -shared -o $@ ${DIRMACROS}/`basename $(@F) _${VER}.so  | sed s/lib//`.cxx ${DIRMACROS}/`basename $(@F) _${VER}.so  | sed s/lib//`link.cxx -I${PAM_INC} -I${DIRTOP}/${DIRINC} -I${DIRTOP} -I${PAM_YODA}/include/yoda ${PAM_YODA}/lib/libyoda.so `root-config --cflags --glibs` 1>/dev/null

${CXXEXELIBS}: ${CXXEXEOBJS}
	@(${EGREEN} "Creating exec file: "${WHITE} "$@"; ${RESET})
	@${CXX} ${CXXFLAGS} -o ${DIRBIN}/$@ ${DIRBIN}/$@.o -I${DIRINC} -I${PAM_INC} -I${PAM_YODA}/include/yoda ${PAM_YODA}/lib/libyoda.so ${DIRTOP}/${DIRLIB}/lib$@_${VER}.so `root-config --cflags --glibs`;
	@rm -f ${DIRSRC}/temp.cc

# A small target to check environmental variables
%_env:
	@${test_env}

.PHONY: install installdoc installlib installmacros installinc installexe installcmacro
.PHONY: clean depclean info mkbindir mklibdir testcern testpamenv test

mkbindir: ${DIRBIN}
${DIRBIN}:
	@${test_and_mk}

mklibdir: ${DIRLIB}
${DIRLIB}:
	@${test_and_mk}

# Here what has to be deleted in clean target
clean: TOBEDEL= ${DIRMACROS}/*link.cxx ${DIRMACROS}/*link.h ${FOBJS} ${FULLLIBS} ${DIRBIN}/${CXXEXELIBS} ${DIRBIN}/${EXESRCS} ${COBJS} ${CXXEXEOBJS} ${FULLLINKFLIBS} ${FULLLINKCLIBS} ${FULLMACROCLIBS} ${FULLLINKMACROCLIBS}
clean:
	@${test_and_rm}

distclean: clean
distclean: TOBEDEL= ${DIRBIN} ${DIRLIB}
distclean:
	@${test_and_rm}

forceinstall: FORCE=-f
forceinstall: install

upgrade: FORCE=-u
upgrade: install

install: installlib installinc installmacros installdoc installexe installcmacro

installlib: LINK=y
installlib: TOBEMOVED= $(FULLLIBS:${DIRLIB}%=${PAM_LIB}%)
installlib: ORIGIN=${DIRLIB}
installlib:
	@${test_and_cp}

installcmacro: LINK=y
installcmacro: TOBEMOVED= $(FULLMACROCLIBS:${DIRLIB}%=${PAM_LIB}%)
installcmacro: ORIGIN=${DIRLIB}
installcmacro:
	@${test_and_cp}

installinc: TOBEMOVED= $(INCSRCS:${DIRINC}/%=${PAM_INC}/%)
installinc: ORIGIN=${DIRINC}
installinc:
	@${test_and_cp}

installexe: TOBEMOVED= $(EXESRCS:${DIRBIN}/%=${PAM_BIN}/%)
installexe: ORIGIN=${DIRBIN}
installexe:
	@${test_and_cp}

installmacros: TOBEMOVED= $(MACROSSRCS:${DIRMACROS}/%=${PAM_MACROS}/%)
installmacros: ORIGIN=${DIRMACROS}
installmacros:
	@${test_and_cp}

installdoc: TOBEMOVED= $(DOCFILES:${DIRDOC}/%=${PAM_DOC}/%)
installdoc: ORIGIN=${DIRDOC}
installdoc:
	@${test_and_cp}

info:
	@echo " "
	@${EGREEN} "Infos for package :" ${WHITE} ${PACKAGE}
	@${EGREEN} "          VERSION :" ${WHITE} ${VER}
	@${EGREEN} "      EXECUTABLES :" ${WHITE} ${EXECUTABLES}
	@${EGREEN} "             LIBS :" ${WHITE} ${LIBS}
	@${EGREEN} "             DOCS :" ${WHITE} ${DOCS}
	@${EGREEN} "             SRCS :" ${WHITE} ${SRCS}
	@${EGREEN} "           MACROS :" ${WHITE} ${MACROS}
	@echo " "
	@${RESET}

test: testpamenv 

testpamenv: ${PAM_ENV}

root-config: OPT=--cflags
root-config: 
	@${test_cmd}

# Here follows some usefull macros
define 	test_and_cp
wd=`pwd`;\
for i in ${TOBEMOVED} ; do \
wv=$${i##/*/}; \
dest=$${i/$${wv}/}; \
${EGREEN} "Testing for :" ${WHITE} "$${i}" ; ${RESET}; \
if [ ! "${FORCE}" ] ; then \
 if [ ! -f $${i} ]; then  \
  ${EGREEN} "Copying : "${WHITE} ${ORIGIN}/$${i##/*/} ;\
  ${EGREEN} "      to: "${WHITE} $${i} ; ${RESET}; \
  cp ${ORIGIN}/$${i##/*/} $${i}; \
 else \
   ${ERED} "File already exist !!!! Please delete it " ${WHITE}; ${RESET}; \
 fi;\
else \
   if [ "${FORCE}" == "-u" ] ; then \
     if [ "`basename $${i}`" != "`basename $${i} _${VER}.so`" ]; then \
       ${EYELLOW} "Removing: "${WHITE} ${PAM_LIB}/`basename $${i} _${VER}.so`_v*r*.so; ${RESET}; \
       rm -f ${PAM_LIB}/`basename $${i} _${VER}.so`_v*r*.so ; \
       ${EGREEN} "Copying : "${WHITE} ${ORIGIN}/$${i##/*/} ;\
       ${EGREEN} "      to: "${WHITE} $${i} ; ${RESET}; \
       cp ${ORIGIN}/$${i##/*/} $${i}; \
     else \
       ${EYELLOW} " Forcing copy: "${WHITE} ${ORIGIN}/$${i##/*/} ;\
       ${EYELLOW} "          to: "${WHITE} $${i} ; ${RESET}; \
       cp -f ${ORIGIN}/$${i##/*/} $${i}; \
     fi; \
   else \
     ${EYELLOW} " Forcing copy: "${WHITE} ${ORIGIN}/$${i##/*/} ;\
     ${EYELLOW} "          to: "${WHITE} $${i} ; ${RESET}; \
     cp ${FORCE} ${ORIGIN}/$${i##/*/} $${i}; \
   fi;\
fi ;\
if [ ! -z ${LINK} ] ; then \
  ${EGREEN} "Creating symlink from : "${WHITE} $${wv/_${VER}/} ;\
  ${EGREEN} "                   to : "${WHITE} $${i##/*/} ; ${RESET}; \
  cd $${dest}; \
  ln -sf $${wv} $${wv/_${VER}/}; \
  cd $${wd}; \
fi \
done
endef

define 	test_and_mk
${EGREEN} "Testing for :" ${WHITE} "$@"; ${RESET}
test -d "$@" || \
(${EGREEN} "Creating : "${WHITE} "$@"; ${RESET}; mkdir -p $@)
endef

define 	test_env
${EGREEN} "Testing for env:" ${WHITE} $(patsubst %_env,%,$@); ${RESET}
printenv $(patsubst %_env,%,$@) 1>/dev/null || \
(${ERED} "ERROR, variable : "${WHITE} $(patsubst %_env,%,$@) \
${RED} "not defined !!! Check your env. settings"; \
${RESET}; exit 1) 
${EGREEN} " Defined:" ${WHITE} $${$(patsubst %_env,%,$@)}; ${RESET} 
endef

define 	test_cmd
${EGREEN} "Testing for cmd:" ${WHITE} $@ ${OPT}; ${RESET}
$@ ${OPT} 1>/dev/null 2>&1 || \
(${ERED} "ERROR, command : "${WHITE} $@ ${OPT}\
${RED} "not found !!! Check your installation"; \
${RESET}; exit 1) 
${EGREEN} " Present:" ${WHITE} $@ ${OPT}; ${RESET} 
endef

define 	test_and_rm
for i in ${TOBEDEL}; do \
test -d $${i} || (${ERED} "Removing file :"${WHITE} $${i}; ${RESET}; \
rm -f $${i} ); \
test ! -d $${i} || (${ERED} "Removing dir :"${WHITE} $${i}; ${RESET}; \
rm -rf $${i} ); \
done
endef
